/*!
 * echarts-extension-amap 
 * @version 1.12.0
 * @author plainheart
 * 
 * MIT License
 * 
 * Copyright (c) 2019-2024 Zhongxiang Wang
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 * 
 */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?t(exports,require("echarts/lib/echarts")):"function"==typeof define&&define.amd?define(["exports","echarts"],t):t(((e="undefined"!=typeof globalThis?globalThis:e||self).echarts=e.echarts||{},e.echarts.amap={}),e.echarts)}(this,(function(e,t){"use strict";var n=t.version.split("."),a=n[0]>4,o="amap";var i={};function r(e,t,n){var a="[ECharts][Extension][AMap]".concat(e?" "+e+":":""," ").concat(t);n&&i[a]||console.warn(a),n&&(i[a]=!0)}function s(e,n){return n=n||[0,0],t.util.map([0,1],(function(t){var a=n[t],o=e[t]/2,i=[],r=[];return i[t]=a-o,r[t]=a+o,i[1-t]=r[1-t]=n[1-t],Math.abs(this.dataToPoint(i)[t]-this.dataToPoint(r)[t])}),this)}var c=["echartsLayerZIndex","echartsLayerInteractive","renderOnMoving","largeMode","returnMapCameraState","layers"];function p(e,t){this._amap=e,this._api=t,this._mapOffset=[0,0]}var h=p.prototype;h.setZoom=function(e){this._zoom=e},h.setCenter=function(e){var t=new AMap.LngLat(e[0],e[1]);this._center=this._amap.lngLatToContainer(t)},h.setMapOffset=function(e){this._mapOffset=e},h.setAMap=function(e){this._amap=e},h.getAMap=function(){return this._amap},h.dataToPoint=function(e){var t=new AMap.LngLat(e[0],e[1]),n=this._amap.lngLatToContainer(t),a=this._mapOffset;return[n.x-a[0],n.y-a[1]]},h.pointToData=function(e){var t=this._mapOffset,n=this._amap.containerToLngLat(new AMap.Pixel(e[0]+t[0],e[1]+t[1]));return[n.lng,n.lat]},h.getViewRect=function(){var e=this._api;return new t.graphic.BoundingRect(0,0,e.getWidth(),e.getHeight())},h.getRoamTransform=function(){return t.matrix.create()},h.prepareCustoms=function(){var e=this.getViewRect();return{coordSys:{type:o,x:e.x,y:e.y,width:e.width,height:e.height},api:{coord:t.util.bind(this.dataToPoint,this),size:t.util.bind(s,this)}}},h.convertToPixel=function(e,t,n){return this.dataToPoint(n)},h.convertFromPixel=function(e,t,n){return this.pointToData(n)},p.create=function(e,n){var a;return e.eachComponent(o,(function(e){if("undefined"==typeof AMap)throw new Error("AMap api is not loaded");if(a)throw new Error("Only one amap component is allowed");var i=e.getAMap(),s=e.get("echartsLayerInteractive");if(!i){var h=n.getDom(),m=n.getZr().painter,l=m.getViewportRoot();l.className=o+"-ec-layer",l.style.visibility="hidden";var d="ec-extension-"+o,f=h.querySelector("."+d);f&&(l.style.left="0px",l.style.top="0px",h.removeChild(f)),(f=document.createElement("div")).className=d,f.style.cssText="position:absolute;top:0;left:0;bottom:0;right:0;",h.appendChild(f);var u=t.util.clone(e.get());"echartsLayerZIndex"in u&&r("DEPRECATED","the option `echartsLayerZIndex` has been removed since v1.9.0, use `echartsLayerInteractive` instead."),t.util.each(c,(function(e){delete u[e]})),(i=new AMap.Map(f,u)).on("complete",(function(){f.querySelector(".amap-maps").appendChild(l),l.style.visibility=""})),e.setAMap(i),e.setEChartsLayer(l),m.getViewportRootOffset=function(){return{offsetLeft:0,offsetTop:0}}}e.__echartsLayerInteractive!==s&&(e.setEChartsLayerInteractive(s),e.__echartsLayerInteractive=s);var v=e.get("center"),g=e.get("zoom");if(v&&g){var y=i.getCenter(),_=i.getZoom();e.centerOrZoomChanged([y.lng,y.lat],_)&&i.setZoomAndCenter(g,new AMap.LngLat(v[0],v[1]))}var L=e.__mapStyle,M=e.get("mapStyle");if(L!==M&&i.setMapStyle(e.__mapStyle=M),i.setLang){var C=e.__mapLang,A=e.get("lang");C!==A&&i.setLang(e.__mapLang=A)}else r("CAVEAT","The current map doesn't support `setLang` API!",!0);(a=new p(i,n)).setMapOffset(e.__mapOffset||[0,0]),a.setZoom(g),a.setCenter(v),e.coordinateSystem=a})),e.eachSeries((function(e){e.get("coordinateSystem")===o&&(e.coordinateSystem=a)})),a&&[a]},h.dimensions=p.dimensions=["lng","lat"],h.type=o;var m,l={type:o,setAMap:function(e){this.__amap=e},getAMap:function(){return this.__amap},setEChartsLayer:function(e){this.__echartsLayer=e},getEChartsLayer:function(){return this.__echartsLayer},setEChartsLayerVisibility:function(e){this.__echartsLayer.style.display=e?"block":"none"},setEChartsLayerInteractive:function(e){this.option.echartsLayerInteractive=!!e,this.__echartsLayer.style.pointerEvents=e?"auto":"none"},setCenterAndZoom:function(e,t){this.option.center=e,this.option.zoom=t},centerOrZoomChanged:function(e,t){var n,a,o=this.option;return a=o.center,!((n=e)&&a&&n[0]===a[0]&&n[1]===a[1]&&t===o.zoom)},defaultOption:{center:[116.397428,39.90923],zoom:5,isHotspot:!1,resizeEnable:!0,echartsLayerInteractive:!0,renderOnMoving:!0,largeMode:!1,returnMapCameraState:!1}},d=a?t.ComponentModel.extend(l):l,f={type:o,init:function(){this._isFirstRender=!0,m=!AMap.v&&AMap.version&&AMap.version.split(".")[0]>=2},render:function(e,n,a){var o=this,i=!0,r=e.getAMap(),s=a.getZr().painter.getViewportRoot(),c=r.getContainer(),p=e.coordinateSystem,h=e.get("renderOnMoving"),l=e.get("resizeEnable"),d=e.get("largeMode"),f=e.get("returnMapCameraState"),u=r.getViewMode_(),v="3D"===u,g=function(t){if(!i){var n=c.style,o=[-parseInt(n.left,10)||0,-parseInt(n.top,10)||0],h=s.style,m=o[0]+"px",l=o[1]+"px";h.left!==m&&(h.left=m),h.top!==l&&(h.top=l),p.setMapOffset(e.__mapOffset=o);var d={type:"amapRoam",animation:{duration:0}};if(f){var v=(t=t||{}).center;v||(v=[(v=r.getCenter()).lng,v.lat]),d.camera={viewMode:u,center:v,zoom:t.zoom||r.getZoom(),rotation:null==t.rotation?r.getRotation():t.rotation,pitch:null==t.pitch?r.getPitch():t.pitch,scale:r.getScale(),bounds:r.getBounds()}}a.dispatchAction(d)}};if(r.off("mapmove",this._moveHandler),r.off("moveend",this._moveHandler),r.off("viewchange",this._moveHandler),r.off("camerachange",this._moveHandler),r.off("zoom",this._moveHandler),this._resizeHandler&&r.off("resize",this._resizeHandler),this._moveStartHandler&&r.off("movestart",this._moveStartHandler),this._moveEndHandler&&(r.off("moveend",this._moveEndHandler),r.off("zoomend",this._moveEndHandler)),r.on(h?m?"viewchange":v?"camerachange":"mapmove":"moveend",!m&&d?g=t.throttle(g,20,!0):g),this._moveHandler=g,!h||m&&v||r.on("zoom",g),!h){r.on("movestart",this._moveStartHandler=function(){setTimeout((function(){e.setEChartsLayerVisibility(!1)}),0)});var y=this._moveEndHandler=function(t){(!t||"moveend"!==t.type)&&g(t),setTimeout((function(){e.setEChartsLayerVisibility(!0)}),m||!d?0:20)};if(r.on("moveend",y),r.on("zoomend",y),this._isFirstRender&&v){var _=r.setPitch,L=r.setRotation;r.setPitch=function(){_.apply(this,arguments),y()},r.setRotation=function(){L.apply(this,arguments),y()}}}if(l){var M=function(){clearTimeout(o._resizeTimeout),o._resizeTimeout=setTimeout((function(){return t.getInstanceByDom(a.getDom()).resize()}),0)};!m&&d&&(M=t.throttle(M,20,!0)),r.on("resize",this._resizeHandler=M)}this._isFirstRender=i=!1},dispose:function(){clearTimeout(this._resizeTimeout),i={};var e=this.__model;e&&(e.getAMap().destroy(),e.setAMap(null),e.setEChartsLayer(null),e.coordinateSystem&&(e.coordinateSystem.setAMap(null),e.coordinateSystem=null)),delete this._moveHandler,delete this._moveStartHandler,delete this._moveEndHandler,delete this._resizeHandler,delete this._resizeTimeout}},u=a?t.ComponentView.extend(f):f;function v(e){(!a||5==n[0]&&n[1]<4)&&e.registerLayout((function(e){e.eachSeriesByType("pie",(function(e){var t=e.coordinateSystem,n=e.getData(),a=n.mapDimension("value");if(t&&t.type===o){var i=e.get("center"),r=t.dataToPoint(i),s=r[0],c=r[1];n.each(a,(function(e,t){var a=n.getItemLayout(t);a.cx=s,a.cy=c}))}}))})),a?e.registerComponentModel(d):e.extendComponentModel(d),a?e.registerComponentView(u):e.extendComponentView(u),e.registerCoordinateSystem(o,p),e.registerAction({type:o+"Roam",event:o+"Roam",update:"updateLayout"},(function(e,t){t.eachComponent(o,(function(e){var t=e.getAMap(),n=t.getCenter();e.setCenterAndZoom([n.lng,n.lat],t.getZoom())}))}))}a?t.use(v):v(t),e.name="echarts-extension-amap",e.version="1.12.0"}));
//# sourceMappingURL=echarts-extension-amap.min.js.map
